function dIdz_est = Estimate_dIdz(phi,I0z,pixelsize,k)

phi = EvenFlip(phi);
I0z = EvenFlip(I0z);

% Coordinates in frequency domain..........................................
[Ny,Nx] = size(phi);
nx = 1:Nx;
ny = 1:Ny;
u = ((nx-1)-Nx/2)/(pixelsize*Nx);
v = ((ny-1)-Ny/2)/(pixelsize*Ny);
[fx,fy] = meshgrid(u,v); 
fx = fftshift(fx);
fy = fftshift(fy);

Cx = 2*1i*pi*fx;
Cy = 2*1i*pi*fy;

Fphi = fft2(phi);
Fdphidx = Fphi.*Cx;
Fdphidy = Fphi.*Cy;
dphidx = real(ifft2(Fdphidx));
dphidy = real(ifft2(Fdphidy));

dPsidx = I0z.*dphidx;
dPsidy = I0z.*dphidy;

FdPsidx = fft2(dPsidx);
FdPsidy = fft2(dPsidy);

Fd2Psidx2 = FdPsidx.*Cx;
Fd2Psidy2 = FdPsidy.*Cy;

d2Psidx2 = real(ifft2(Fd2Psidx2));
d2Psidy2 = real(ifft2(Fd2Psidy2));

laplacePsi = d2Psidx2+d2Psidy2;

dIdz_est = laplacePsi./(-k);
dIdz_est = dIdz_est(1:end/2,1:end/2); % optional result.
end

% subfunctions.
function AA = EvenFlip(A)

temp = [A,fliplr(A)];
AA = [temp',(flipud(temp))']';

end
